<?php

// Default Options
add_option( 'invkp_revenue_currency', '$' );
add_option( 'invkp_comany_name', '' );
add_option( 'invkp_address', '' );
add_option( 'invkp_suburb', '' );
add_option( 'invkp_state', '' );
add_option( 'invkp_postcode', '' );
add_option( 'invkp_phone', '' );
add_option( 'invkp_email', '' );

add_option( 'invkp_invoice_type', 'INVOICE' );
add_option( 'invkp_paid_invoice_type', 'RECEIPT' );
add_option( 'invkp_paid_watermark', 'PAID' );
add_option( 'invkp_invoice_no_label', 'Invoice #:' );
add_option( 'invkp_po_label', 'PO:' );
add_option( 'invkp_attn_name_label', 'Attn:' );
add_option( 'invkp_tax_label', 'GST' );

add_option( 'invkp_open_content_1', '');
add_option( 'invkp_open_content_2', '');

add_option( 'invkp_columns', '' );

add_option( 'invkp_theme', 'default' );

add_option( 'invkp_calculate_rows', '' );
add_option( 'invkp_calculate_operators', '' );

add_option( 'invkp_calculate_subtotal', 'Total ($)');

add_option( 'invkp_from', get_bloginfo('name'));
add_option( 'invkp_from_email', get_bloginfo('admin_email'));
add_option( 'invkp_email_subject', "{{invoice_type}} From ".get_bloginfo('name'));
$message = "Hi {{client_name}},"."\r\n\r\n";
$message .= 'Please find attached the {{invoice_type}} for ${{invoice_total}}.'."\r\n\r\n";

$message .= "Regards,"."\r\n";
$message .= get_bloginfo('name');
add_option( 'invkp_email_message', $message);
add_option( 'invkp_paid_email_subject', "{{invoice_type}} From ".get_bloginfo('name'));
$message = "Hi {{client_name}},"."\r\n\r\n";
$message .= 'Please find attached the {{invoice_type}} for {{invoice_number_label}}{{invoice_number}}.'."\r\n";
$message .= 'Thank you for your business'."\r\n\r\n";

$message .= "Regards,"."\r\n";
$message .= get_bloginfo('name');
add_option( 'invkp_paid_email_message', $message);

$pdf_theme = get_option('invkp_theme');
if (file_exists(str_replace("includes/","",plugin_dir_path(__FILE__)).'themes/'.$pdf_theme.'/theme_options.php')) {
    include str_replace("includes/","",plugin_dir_path(__FILE__)).'themes/'.$pdf_theme.'/theme_options.php';
}

// Register Post types for invoicing
function invkp_create_post_type() {
    register_post_type( 'invkp_invoices',
        array(
            'labels' => array(
                'name' => __( 'Invoices' ),
                'singular_name' => __( 'Invoice' ),
                'all_items'=>'All Invoices',
                'edit_item'=>'Edit Invoice',
                'update_item'=>'Update Invoice',
                'add_new_item'=>'Add New Invoice',
                'new_item_name'=>'New Invoice',
                'add_new' => 'Add New',
                'new_item' => 'New Invoice',
                'view_item' => 'View Invoice',
                'search_items' => 'Search Invoices',
                'not_found' =>  'No invoices found',
                'not_found_in_trash' => 'No invoices found in Trash', 
                'parent_item_colon' => '',
                'menu_name' => 'Invoices'
            ),
            'public' => true,
            'exclude_from_search' => true,
            'menu_position' => 5,
            'supports' => array('title')
        )
    );
    
    register_post_type( 'invkp_clients',
        array(
            'labels' => array(
                'name' => __( 'Clients' ),
                'singular_name' => __( 'Client' ),
                'all_items'=>'All Clients',
                'edit_item'=>'Edit Client',
                'update_item'=>'Update Client',
                'add_new_item'=>'Add New Client',
                'new_item_name'=>'New Client',
                'add_new' => 'Add New',
                'new_item' => 'New Client',
                'view_item' => 'View Client',
                'search_items' => 'Search Clients',
                'not_found' =>  'No clients found',
                'not_found_in_trash' => 'No clients found in Trash', 
                'parent_item_colon' => '',
                'menu_name' => 'Clients'
            ),
            'public' => true,
            'exclude_from_search' => true,
            'show_in_menu' => 'edit.php?post_type=invkp_invoices',
            'supports' => array('title')
        )
    );
}
add_action( 'init', 'invkp_create_post_type' );

// Styling for the custom post type icon
function wpt_invkp_icons() {
    ?>
    <style type="text/css" media="screen">
        #menu-posts-invkp_invoices .wp-menu-image {
            background: url(<?= plugins_url('/images/invkp-icon_16x16_sat.png', dirname(__FILE__)) ?>) no-repeat center center !important;
        }
	#menu-posts-invkp_invoices:hover .wp-menu-image, #menu-posts-invkp_invoices.wp-has-current-submenu .wp-menu-image {
            background: url(<?= plugins_url('/images/invkp-icon_16x16.png', dirname(__FILE__)) ?>) no-repeat center center !important;
        }
	#icon-edit.icon32-posts-invkp_invoices {background: url(<?= plugins_url('/images/invkp-icon_32x32_sat.png', dirname(__FILE__)) ?>) no-repeat;}
    </style>
<?php }
add_action( 'admin_head', 'wpt_invkp_icons' );

// Columns in custom post types
function invkp_edit_invoice_columns( $columns ) {

    $columns = array(
        'cb' => '<input type="checkbox" />',
        'title' => __( 'Description' ),
        'invoice_no' => __('Invoice No.'),
        'client' => __( 'Client' ),
        'total' => __( 'Total' ),
        'invoice_paid' => __( 'Paid?' ),
        'date' => __( 'Date' ),
    );

    return $columns;
}
add_filter( 'manage_edit-invkp_invoices_columns', 'invkp_edit_invoice_columns' ) ;

// Update column data with custom data
function invkp_columns($column_name, $ID) {
    switch ($column_name) {
        case 'invoice_no' :
            // Get invoice number
            $invoice_no = get_post_meta($ID, 'invkp_invoice_no');
            echo $invoice_no[0];
            break;
        
        case 'client' :
            // Get client details via client id and output company name and email
            $client = get_post_meta($ID, 'invkp_client_company');
            echo $client[0];
            break;
            
        case 'total' :
            // Get total of invoice
            $total = get_post_meta($ID, 'invkp_total');
            echo $total[0];
            break;
        
        case 'invoice_paid' :
            // Count invoices attached to this client
            $paid = get_post_meta($ID, 'invkp_paid_invoice');
            if (!empty($paid) && $paid[0] == 1) echo "<a href='".admin_url('admin.php?action=invkpmarkunpaid&post='.$ID)."'><img src='".str_replace('includes', 'images', plugin_dir_url(__FILE__))."tick.png' /></a>";
            else echo "<a href='".admin_url('admin.php?action=invkpmarkpaid&post='.$ID)."'><img src='".str_replace('includes', 'images', plugin_dir_url(__FILE__))."cross.png' /></a>";
            break;
    }
}
add_action('manage_invkp_invoices_posts_custom_column', 'invkp_columns', 10, 2); 

// Columns in custom post types
function invkp_edit_client_columns( $columns ) {

    $columns = array(
        'cb' => '<input type="checkbox" />',
        'title' => __( 'Company Name' ),
        'email' => __( 'Attached Email' ),
        'invoices_attached' => __( 'Invoices' ),
    );

    return $columns;
}
add_filter( 'manage_edit-invkp_clients_columns', 'invkp_edit_client_columns' ) ;

// Update column data with custom data
function invkp_client_columns($column_name, $ID) {
    switch ($column_name) {
        case 'email' :
            // Get client email
            $email = get_post_meta($ID, 'invkp_client_email');
            echo $email[0];
            break;
            
        case 'invoices_attached' :
            // Count invoices attached to this client
            $invoices = query_posts(array('post_type'=>'invkp_invoices', 'meta_key'=>'invkp_client_link', 'meta_value'=>$ID));
            echo count($invoices);
            break;
    }
}
add_action('manage_invkp_clients_posts_custom_column', 'invkp_client_columns', 10, 2); 

function invkp_action_row($actions){
    global $post;
   if ($post->post_type == "invkp_invoices"){
      //remove what you don't need
       unset( $actions['inline hide-if-no-js'] );
       unset( $actions['view'] );
       
       $paid_invoice = get_post_meta($post->ID, 'invkp_paid_invoice');
       if (!empty($paid_invoice) && $paid_invoice[0] == 1)
           $actions['markunpaid'] = '<a href=\''.admin_url('admin.php?action=invkpmarkunpaid&post='.$post->ID).'\'>Mark Unpaid</a>';
       else
           $actions['markpaid'] = '<a href=\''.admin_url('admin.php?action=invkpmarkpaid&post='.$post->ID).'\'>Mark Paid</a>';
       $actions['viewpdf'] = '<a href=\''.admin_url('admin.php?action=invkpviewpdf&post='.$post->ID).'\' target=\'blank\'>View PDF</a>';
       $actions['emailpdf'] = '<a href=\''.admin_url('admin.php?action=invkpemailpdf&post='.$post->ID).'\'>Email PDF</a>';
   }
   return $actions;
}
add_filter('post_row_actions','invkp_action_row');

function invkpmarkpaid_admin_action()
{
    $post_id = $_GET['post'];
    update_post_meta( $post_id, 'invkp_paid_invoice', 1 );
    
    header("Location: ".$_SERVER['HTTP_REFERER']);
    
}
add_action( 'admin_action_invkpmarkpaid', 'invkpmarkpaid_admin_action' );

function invkpmarkunpaid_admin_action()
{
    $post_id = $_GET['post'];
    update_post_meta( $post_id, 'invkp_paid_invoice', 0 );
    
    header("Location: ".$_SERVER['HTTP_REFERER']);
    
}
add_action( 'admin_action_invkpmarkunpaid', 'invkpmarkunpaid_admin_action' );

function invkpviewpdf_admin_action()
{
    include plugin_dir_path(__FILE__)."../packages/fpdf/fpdf.php";
    $post_id = $_GET['post'];
    $invoice = query_posts(array('post_type'=>'invkp_invoices', 'p'=>$post_id));
    $invoice[0]->custom = invkp_return_fields($post_id);
    if (isset($invoice[0]->custom['invkp_column'][0])) {
        if (!is_array($invoice[0]->custom['invkp_column'][0]))
            $rows = unserialize($invoice[0]->custom['invkp_column'][0]); 
        else $rows = $invoice[0]->custom['invkp_column'][0];
    }
    $columns = unserialize($invoice[0]->custom['invkp_columns'][0]);
    $currency_symbol = get_option('invkp_revenue_currency');
    $tax_label = get_option("invkp_tax_label");
    $paid_label = get_option("invkp_paid_invoice_type");
    $paid_watermark = get_option('invkp_paid_watermark');
    //print_r($invoice[0]->custom);die;
    
    $pdf_theme = get_option('invkp_theme');
    if (file_exists(str_replace("includes/","",plugin_dir_path(__FILE__)).'themes/'.$pdf_theme.'/pdf.php'))
        include str_replace("includes/","",plugin_dir_path(__FILE__)).'themes/'.$pdf_theme.'/pdf.php';
    else
        include 'pdf.php';
    
    header("Location: ".str_replace("includes/","",plugin_dir_url(__FILE__))."outputs/".$invoice[0]->ID.".pdf");
    
}
add_action( 'admin_action_invkpviewpdf', 'invkpviewpdf_admin_action' );

function invkpemailpdf_admin_action()
{
    global $wpdb;
    $post_id = $_GET['post'];
    $invoice = query_posts(array('post_type'=>'invkp_invoices', 'p'=>$post_id));
    $invoice[0]->custom = invkp_return_fields($post_id);
    
    if (isset($invoice[0]->custom['invkp_selected_client_email'][0]) && $invoice[0]->custom['invkp_selected_client_email'][0] !== '')
        $email = $invoice[0]->custom['invkp_selected_client_email'][0];
    elseif (isset($invoice[0]->custom['invkp_client_email'][0]) && $invoice[0]->custom['invkp_client_email'][0] !== '')
        $email = $invoice[0]->custom['invkp_client_email'][0];
    else header("Location: ".$_SERVER['HTTP_REFERER']."&send=0");
    
    $name = $invoice[0]->custom['invkp_selected_client_attn'][0];
    
    $from = get_option('invkp_from');
    $from_email = get_option('invkp_from_email');
    
    $headers = "From: ".$from." <".$from_email.">";
    
    include plugin_dir_path(__FILE__)."../packages/fpdf/fpdf.php";
    if (isset($invoice[0]->custom['invkp_column'][0])) {
        if (!is_array($invoice[0]->custom['invkp_column'][0]))
            $rows = unserialize($invoice[0]->custom['invkp_column'][0]); 
        else $rows = $invoice[0]->custom['invkp_column'][0];
    }
    $columns = unserialize($invoice[0]->custom['invkp_columns'][0]);
    $currency_symbol = get_option('invkp_revenue_currency');
    $tax_label = get_option("invkp_tax_label");
    $paid_label = get_option("invkp_paid_invoice_type");
    $paid_watermark = get_option('invkp_paid_watermark');
    
    $pdf_theme = get_option('invkp_theme');
    if (file_exists(str_replace("includes/","",plugin_dir_path(__FILE__)).'themes/'.$pdf_theme.'/pdf.php'))
        include str_replace("includes/","",plugin_dir_path(__FILE__)).'themes/'.$pdf_theme.'/pdf.php';
    else
        include 'pdf.php';
    
    $attachments = array(str_replace("includes/","",plugin_dir_path(__FILE__))."outputs/".$invoice[0]->ID.".pdf");
    
    if ($invoice[0]->custom['invkp_paid_invoice'][0] == 1) {
        $paid = 'paid_';
        $invoice_type = $paid_label;
    } else {
        $paid = '';
        $invoice_type = $invoice[0]->custom['invkp_invoice_type'][0];
    }
    
    $search = array(
        '{{invoice_type}}',
        '{{invoice_number_label}}',
        '{{invoice_number}}',
        '{{invoice_date}}',
        '{{invoice_due_date}}',
        '{{client_company_name}}',
        '{{client_name}}',
        '{{invoice_total}}',
    );
    $replace = array(
        $invoice_type,
        $invoice[0]->custom['invkp_invoice_no_label'][0],
        $invoice[0]->custom['invkp_invoice_no'][0],
        $invoice[0]->custom['invkp_date'][0],
        $invoice[0]->custom['invkp_due_date'][0],
        $invoice[0]->custom['invkp_selected_client_company'][0],
        $invoice[0]->custom['invkp_selected_client_attn'][0],
        $invoice[0]->custom['invkp_total'][0],
    );
    $subject = str_replace($search, $replace, get_option('invkp_'.$paid.'email_subject'));
    $message = str_replace($search, $replace, get_option('invkp_'.$paid.'email_message'));

    if (@wp_mail($email, $subject, $message, $headers, $attachments)) $sent = 1; else $sent = 0;
    
    header("Location: ".$_SERVER['HTTP_REFERER']."&send=".$sent);
}
add_action( 'admin_action_invkpemailpdf', 'invkpemailpdf_admin_action' );

// Update title field to become URL field
function invkp_title_text_input( $title ){
    global $post;
    if($post->post_type == 'invkp_invoices') 
        return $title = 'Invoice Description for your convinence';
    if($post->post_type == 'invkp_clients')
        return $title = 'Company Name';
    return $title;
}
add_filter( 'enter_title_here', 'invkp_title_text_input' );

// Update Feature Image to become Advert Image
function invkp_change_meta_boxes()
{
    add_meta_box('postinvoicedatadiv', __('Invoice'), 'invkp_post_invoice', 'invkp_invoices', 'advanced', 'high');
    add_meta_box('postinvoiceoptionsdatadiv', __('Invoice Options'), 'invkp_post_invoice_options', 'invkp_invoices', 'side', 'high');
    add_meta_box('postinvoiceclientdatadiv', __('Client Details'), 'invkp_post_client_details', 'invkp_invoices', 'side', 'high');
    
    add_meta_box('postclientdatadiv', __('Client Details'), 'invkp_post_client', 'invkp_clients', 'advanced', 'high');
}
add_action('do_meta_boxes', 'invkp_change_meta_boxes');

// Output stats for post
function invkp_post_client($object, $box) {
    global $wpdb;
    global $post;
    $custom_fields = invkp_return_client_fields();
    $inv_nonce = wp_create_nonce(basename(__FILE__));
    echo '<input type="hidden" name="invkp_client_meta_box_nonce" value="'.$inv_nonce.'" />';
    echo '<div><label>Company Contact Name:</label><input type="text" name="invkp_client_attn_name" value="'.$custom_fields['invkp_client_attn_name'][0].'" /></div>';
    echo '<div><label>Address:</label><input type="text" name="invkp_client_address" value="'.$custom_fields['invkp_client_address'][0].'" /></div>';
    echo '<div class="left"><label>Suburb:</label><input type="text" name="invkp_client_suburb" value="'.$custom_fields['invkp_client_suburb'][0].'" /></div>';
    echo '<div class="right"><label>State:</label><input type="text" name="invkp_client_state" value="'.$custom_fields['invkp_client_state'][0].'" /></div>';
    echo '<div class="left"><label>Postcode/Zip:</label><input type="text" name="invkp_client_postcode" value="'.$custom_fields['invkp_client_postcode'][0].'" /></div>';
    echo '<div class="left"><label>Email:</label><input type="text" name="invkp_client_email" value="'.$custom_fields['invkp_client_email'][0].'" /></div>';
    echo '<div class="right"><label>Phone:</label><input type="text" name="invkp_client_phone" value="'.$custom_fields['invkp_client_phone'][0].'" /></div>';
}

function invkp_post_invoice($object, $box) {
    global $wpdb;
    global $post;
    $custom_fields = invkp_return_fields();
    $inv_nonce = wp_create_nonce(basename(__FILE__));
    
    if (isset($custom_fields["invkp_column"][0])) {
        if (!is_array($custom_fields['invkp_column'][0]))
            $rows = unserialize($custom_fields['invkp_column'][0]); 
        else $rows = $custom_fields['invkp_column'][0];
    }
    
    if (isset($custom_fields["invkp_columns"][0])) $columns = unserialize($custom_fields["invkp_columns"][0]);
    else $columns = get_option('invkp_columns');
    //$columns = get_option('invkp_columns');
    if (isset($custom_fields["invkp_calculate_rows"][0])) $calc_cols = unserialize($custom_fields["invkp_calculate_rows"][0]);
    else $calc_cols = get_option('invkp_calculate_rows');
    //$calc_cols = get_option('invkp_calculate_rows');
    if (isset($custom_fields["invkp_calculate_operators"][0])) $calc_ops = unserialize($custom_fields["invkp_calculate_operators"][0]);
    else $calc_ops = get_option('invkp_calculate_operators');
    //$calc_ops = get_option('invkp_calculate_operators');
    if (isset($custom_fields["invkp_calculate_subtotal"][0])) $subtotal_col = $custom_fields["invkp_calculate_subtotal"][0];
    else $subtotal_col = get_option('invkp_calculate_subtotal');
    if (!isset($calc_ops[0])) {
        echo "Please visit the settings page to setup your defaults for the invoice";
        echo "<br /><br />";
        echo "<a href='".admin_url('/options-general.php?page=invoicekingpro')."'>Settings Page</a>";
        return;
    }
    $row_calc = array();
    if (!empty($calc_cols) && $calc_ops[0] <> '') :
        for ($c=0;$c<count($calc_cols); $c++) :
            $row_calc[] = preg_replace('~[^\p{L}\p{N}]++~u', '', $calc_cols[$c]);
            if (isset($calc_ops[$c]) && $calc_ops[$c] <> '') :
                $row_calc[] = $calc_ops[$c];
            endif;
        endfor; 
    endif;
    $json_calc = json_encode($row_calc);
    $pdf_theme = get_option('invkp_theme');
    if (file_exists(str_replace("includes/","",plugin_dir_path(__FILE__)).'themes/'.$pdf_theme.'/invoice_html.php'))
        include str_replace("includes/","",plugin_dir_path(__FILE__)).'themes/'.$pdf_theme.'/invoice_html.php';
    else
        include('invoice_html.php');
}

function invkp_post_invoice_options($object, $box) {
    global $wpdb;
    global $post;
    $discount_type = get_post_meta( $post->ID, 'invkp_discount_type', true );
    $discount_value = get_post_meta( $post->ID, 'invkp_discount_value', true );
    $tax_percentage = get_post_meta( $post->ID, 'invkp_tax_percentage', true );
    $paid_invoice = get_post_meta( $post->ID, 'invkp_paid_invoice', true );
    $checked = '';
    if ($paid_invoice == "1") $checked = ' checked';
    
    echo '<div class="misc-pub-section"><label for="invkp_discount_type">Discount Type:</label>';
    echo '<select name="invkp_discount_type" id="invkp_discount_type" style="float: right;margin-top: -3px;"><option value="percentage"', ($discount_type == 'percentage') ? ' selected' : '' , '>Percentage</option><option value="setvalue"', ($discount_type == 'setvalue') ? ' selected' : '' , '>Set Value</option></select>';
    echo '</div>';
    echo '<div class="misc-pub-section"><label for="invkp_discount_value">Discount Value:</label>';
    echo '<input type="text" name="invkp_discount_value" id="invkp_discount_value" value="'. $discount_value .'" class="calculate" style="width: 70px;float: right;margin-top: -3px;" />';
    echo '</div>';
    echo '<div class="misc-pub-section"><label for="invkp_tax_percentage">Tax Percentage:</label>';
    echo '<input type="text" name="invkp_tax_percentage" id="invkp_tax_percentage" value="'. $tax_percentage .'" class="calculate" style="width: 70px;float: right;margin-top: -3px;" />';
    echo '</div>';
    echo '<div class="misc-pub-section"><label for="invkp_paid_invoice">Invoice Paid?:</label>';
    echo '<input type="hidden" name="invkp_paid_invoice" id="invkp_paid_invoice_no" value="0" />';
    echo '<input type="checkbox" name="invkp_paid_invoice" id="invkp_paid_invoice_yes" value="1"'.$checked.' style="float: right;margin-top: 2px;" />';
    echo '</div>';
}

function invkp_post_client_details($object, $box) {
    global $wpdb;
    global $post;
    
    $output = array();
    $output['invkp_client_link'] = (get_post_meta( $post->ID, 'invkp_client_link' ) ? get_post_meta( $post->ID, 'invkp_client_link' ) : array(''));
    $output['invkp_selected_client_company'] = (get_post_meta( $post->ID, 'invkp_selected_client_company' ) ? get_post_meta( $post->ID, 'invkp_selected_client_company' ) : array(''));
    $output['invkp_selected_client_attn'] = (get_post_meta( $post->ID, 'invkp_selected_client_attn' ) ? get_post_meta( $post->ID, 'invkp_selected_client_attn' ) : array(''));
    $output['invkp_selected_client_address'] = (get_post_meta( $post->ID, 'invkp_selected_client_address' ) ? get_post_meta( $post->ID, 'invkp_selected_client_address' ) : array(''));
    $output['invkp_selected_client_suburb'] = (get_post_meta( $post->ID, 'invkp_selected_client_suburb' ) ? get_post_meta( $post->ID, 'invkp_selected_client_suburb' ) : array(''));
    $output['invkp_selected_client_state'] = (get_post_meta( $post->ID, 'invkp_selected_client_state' ) ? get_post_meta( $post->ID, 'invkp_selected_client_state' ) : array(''));
    $output['invkp_selected_client_postcode'] = (get_post_meta( $post->ID, 'invkp_selected_client_postcode' ) ? get_post_meta( $post->ID, 'invkp_selected_client_postcode' ) : array(''));
    $output['invkp_selected_client_email'] = (get_post_meta( $post->ID, 'invkp_selected_client_email' ) ? get_post_meta( $post->ID, 'invkp_selected_client_email' ) : array(''));
    $output['invkp_selected_client_phone'] = (get_post_meta( $post->ID, 'invkp_selected_client_phone' ) ? get_post_meta( $post->ID, 'invkp_selected_client_phone' ) : array(''));
    
    $clients = query_posts(array('post_type'=>'invkp_clients'));
    $client_dropdown = '';
    foreach ($clients as $client) {
        $client_val = array(
            'id'=>$client->ID,
            'company_name'=>$client->post_title,
            'attn_name'=>get_post_meta( $client->ID, 'invkp_client_attn_name'),
            'address'=>get_post_meta( $client->ID, 'invkp_client_address'),
            'suburb'=>get_post_meta( $client->ID, 'invkp_client_suburb'),
            'state'=>get_post_meta( $client->ID, 'invkp_client_state'),
            'postcode'=>get_post_meta( $client->ID, 'invkp_client_postcode'),
            'email'=>get_post_meta( $client->ID, 'invkp_client_email'),
            'phone'=>get_post_meta( $client->ID, 'invkp_client_phone')
        );
        
        $selected = '';
        //echo $client->ID." = ".$output['invkp_client_link'][0]."<br />";
        if ($client->ID == $output['invkp_client_link'][0]) $selected = ' selected';
        $client_dropdown .= "<option value='".json_encode($client_val)."'".$selected.">".$client->post_title."</option>";
    }
    
    echo '<div class="misc-pub-section" style="margin-bottom: 20px;"><label for="invkp_select_client">Use Existing Client Details:</label>';
    echo '<select id="invkp_select_client" style="display:block;width: 100%;"><option value="">-- SELECT --</option>'.$client_dropdown.'</select>';
    echo '</div>';
    echo '<input type="hidden" name="invkp_client_link" id="invkp_client_link" value="'.$output['invkp_client_link'][0].'" />';
    echo '<div style="margin-bottom: 10px;"><label for="invkp_selected_client_company">Company Name:</label>';
    echo '<input type="text" name="invkp_selected_client_company" id="invkp_selected_client_company" value="'.$output['invkp_selected_client_company'][0].'" style="width: 100%;" /></div>';
    echo '<div style="margin-bottom: 10px;"><label for="invkp_selected_client_company">Company Contact Name:</label>';
    echo '<input type="text" name="invkp_selected_client_attn" id="invkp_selected_client_attn" value="'.$output['invkp_selected_client_attn'][0].'" style="width: 100%;" /></div>';
    echo '<div style="margin-bottom: 10px;"><label for="invkp_selected_client_address">Address:</label>';
    echo '<input type="text" name="invkp_selected_client_address" id="invkp_selected_client_address" value="'.$output['invkp_selected_client_address'][0].'" style="width: 100%;" /></div>';
    echo '<div style="margin-bottom: 10px;"><label for="invkp_selected_client_suburb">Suburb:</label>';
    echo '<input type="text" name="invkp_selected_client_suburb" id="invkp_selected_client_suburb" value="'.$output['invkp_selected_client_suburb'][0].'" style="width: 100%;" /></div>';
    echo '<div style="margin-bottom: 10px;"><label for="invkp_selected_client_state">State:</label>';
    echo '<input type="text" name="invkp_selected_client_state" id="invkp_selected_client_state" value="'.$output['invkp_selected_client_state'][0].'" style="width: 100%;" /></div>';
    echo '<div style="margin-bottom: 10px;"><label for="invkp_selected_client_postcode">Postcode:</label>';
    echo '<input type="text" name="invkp_selected_client_postcode" id="invkp_selected_client_postcode" value="'.$output['invkp_selected_client_postcode'][0].'" style="width: 100%;" /></div>';
    echo '<div style="margin-bottom: 10px;"><label for="invkp_selected_client_email">Email:</label>';
    echo '<input type="text" name="invkp_selected_client_email" id="invkp_selected_client_email" value="'.$output['invkp_selected_client_email'][0].'" style="width: 100%;" /></div>';
    echo '<div style="margin-bottom: 10px;"><label for="invkp_selected_client_phone">Phone:</label>';
    echo '<input type="text" name="invkp_selected_client_phone" id="invkp_selected_client_phone" value="'.$output['invkp_selected_client_phone'][0].'" style="width: 100%;" /></div>';
    echo '<div style="margin-bottom: 10px;">';
    echo '<input type="button" id="insert_details" class="button" value="Insert Details" /><input type="button" id="save_client" class="button-primary right" value="Save Client" />';
    echo '</div>';
}

// Process the custom metabox fields
function invkp_save_custom_fields( ) {
	global $post;	
        
        // verify nonce
        if (!isset($_POST['invkp_meta_box_nonce']) || !wp_verify_nonce($_POST['invkp_meta_box_nonce'], basename(__FILE__))) {
            return;
        }
	
	if( $_POST ) {
            if (isset($_POST['invkp_company_name']))
                update_post_meta( $post->ID, 'invkp_company_name', $_POST['invkp_company_name'] );
            if (isset($_POST['invkp_invoice_type']))
                update_post_meta( $post->ID, 'invkp_invoice_type', $_POST['invkp_invoice_type'] );
            
            if (isset($_POST['invkp_address']))
                update_post_meta( $post->ID, 'invkp_address', $_POST['invkp_address'] );
            if (isset($_POST['invkp_suburb']))
                update_post_meta( $post->ID, 'invkp_suburb', $_POST['invkp_suburb'] );
            if (isset($_POST['invkp_state']))
                update_post_meta( $post->ID, 'invkp_state', $_POST['invkp_state'] );
            if (isset($_POST['invkp_postcode']))
                update_post_meta( $post->ID, 'invkp_postcode', $_POST['invkp_postcode'] );
            if (isset($_POST['invkp_date']))
                update_post_meta( $post->ID, 'invkp_date', $_POST['invkp_date'] );
            if (isset($_POST['invkp_due_date']))
                update_post_meta( $post->ID, 'invkp_due_date', $_POST['invkp_due_date'] );
            if (isset($_POST['invkp_invoice_no_label']))
                update_post_meta( $post->ID, 'invkp_invoice_no_label', $_POST['invkp_invoice_no_label'] );
            if (isset($_POST['invkp_invoice_no']))
                update_post_meta( $post->ID, 'invkp_invoice_no', $_POST['invkp_invoice_no'] );
            if (isset($_POST['invkp_po_label']))
                update_post_meta( $post->ID, 'invkp_po_label', $_POST['invkp_po_label'] );
            if (isset($_POST['invkp_po']))
                update_post_meta( $post->ID, 'invkp_po', $_POST['invkp_po'] );
            if (isset($_POST['invkp_payment_terms']))
                update_post_meta( $post->ID, 'invkp_payment_terms', $_POST['invkp_payment_terms'] );
            
            if (isset($_POST['invkp_phone']))
                update_post_meta( $post->ID, 'invkp_phone', $_POST['invkp_phone'] );
            if (isset($_POST['invkp_email']))
                update_post_meta( $post->ID, 'invkp_email', $_POST['invkp_email'] );
            if (isset($_POST['invkp_add_detail']))
                update_post_meta( $post->ID, 'invkp_add_detail', $_POST['invkp_add_detail'] );
            if (isset($_POST['invkp_attn_name_label']))
                update_post_meta( $post->ID, 'invkp_attn_name_label', $_POST['invkp_attn_name_label'] );
            if (isset($_POST['invkp_attn_name']))
                update_post_meta( $post->ID, 'invkp_attn_name', $_POST['invkp_attn_name'] );
            if (isset($_POST['invkp_client_company']))
                update_post_meta( $post->ID, 'invkp_client_company', $_POST['invkp_client_company'] );
            if (isset($_POST['invkp_client_address']))
                update_post_meta( $post->ID, 'invkp_client_address', $_POST['invkp_client_address'] );
            if (isset($_POST['invkp_client_suburb']))
                update_post_meta( $post->ID, 'invkp_client_suburb', $_POST['invkp_client_suburb'] );
            if (isset($_POST['invkp_client_state']))
                update_post_meta( $post->ID, 'invkp_client_state', $_POST['invkp_client_state'] );
            if (isset($_POST['invkp_client_postcode']))
                update_post_meta( $post->ID, 'invkp_client_postcode', $_POST['invkp_client_postcode'] );
            if (isset($_POST['invkp_client_email']))
                update_post_meta( $post->ID, 'invkp_client_email', $_POST['invkp_client_email'] );
            if (isset($_POST['invkp_client_phone']))
                update_post_meta( $post->ID, 'invkp_client_phone', $_POST['invkp_client_phone'] );
            
            if (isset($_POST['invkp_client_link']))
                update_post_meta( $post->ID, 'invkp_client_link', $_POST['invkp_client_link'] );
            if (isset($_POST['invkp_selected_client_company']))
                update_post_meta( $post->ID, 'invkp_selected_client_company', $_POST['invkp_selected_client_company'] );
            if (isset($_POST['invkp_selected_client_attn']))
                update_post_meta( $post->ID, 'invkp_selected_client_attn', $_POST['invkp_selected_client_attn'] );
            if (isset($_POST['invkp_selected_client_address']))
                update_post_meta( $post->ID, 'invkp_selected_client_address', $_POST['invkp_selected_client_address'] );
            if (isset($_POST['invkp_selected_client_suburb']))
                update_post_meta( $post->ID, 'invkp_selected_client_suburb', $_POST['invkp_selected_client_suburb'] );
            if (isset($_POST['invkp_selected_client_state']))
                update_post_meta( $post->ID, 'invkp_selected_client_state', $_POST['invkp_selected_client_state'] );
            if (isset($_POST['invkp_selected_client_postcode']))
                update_post_meta( $post->ID, 'invkp_selected_client_postcode', $_POST['invkp_selected_client_postcode'] );
            if (isset($_POST['invkp_selected_client_email']))
                update_post_meta( $post->ID, 'invkp_selected_client_email', $_POST['invkp_selected_client_email'] );
            if (isset($_POST['invkp_selected_client_phone']))
                update_post_meta( $post->ID, 'invkp_selected_client_phone', $_POST['invkp_selected_client_phone'] );
            
            if (isset($_POST['invkp_column']))
                update_post_meta( $post->ID, 'invkp_column', $_POST['invkp_column'] );//mysql_real_escape_string(serialize(
            if (isset($_POST['invkp_subtotal']))
                update_post_meta( $post->ID, 'invkp_subtotal', $_POST['invkp_subtotal'] );
            if (isset($_POST['invkp_discount']))
                update_post_meta( $post->ID, 'invkp_discount', $_POST['invkp_discount'] );
            if (isset($_POST['invkp_gst']))
                update_post_meta( $post->ID, 'invkp_gst', $_POST['invkp_gst'] );
            if (isset($_POST['invkp_total']))
                update_post_meta( $post->ID, 'invkp_total', $_POST['invkp_total'] );
            
            if (isset($_POST['invkp_columns']))
                update_post_meta( $post->ID, 'invkp_columns', $_POST['invkp_columns'] );
            if (isset($_POST['invkp_calculate_rows']))
                update_post_meta( $post->ID, 'invkp_calculate_rows', $_POST['invkp_calculate_rows'] );
            if (isset($_POST['invkp_calculate_operators']))
                update_post_meta( $post->ID, 'invkp_calculate_operators', $_POST['invkp_calculate_operators'] );
            if (isset($_POST['invkp_calculate_subtotal']))
                update_post_meta( $post->ID, 'invkp_calculate_subtotal', $_POST['invkp_calculate_subtotal'] );
            
            if (isset($_POST['invkp_open_content_1']))
                update_post_meta( $post->ID, 'invkp_open_content_1', $_POST['invkp_open_content_1'] );
            if (isset($_POST['invkp_open_content_2']))
                update_post_meta( $post->ID, 'invkp_open_content_2', $_POST['invkp_open_content_2'] );
            
            if (isset($_POST['invkp_discount_type']))
                update_post_meta( $post->ID, 'invkp_discount_type', $_POST['invkp_discount_type'] );
            if (isset($_POST['invkp_discount_value']))
                update_post_meta( $post->ID, 'invkp_discount_value', $_POST['invkp_discount_value'] );
            if (isset($_POST['invkp_tax_percentage']))
                update_post_meta( $post->ID, 'invkp_tax_percentage', $_POST['invkp_tax_percentage'] );
            if (isset($_POST['invkp_paid_invoice']))
                update_post_meta( $post->ID, 'invkp_paid_invoice', $_POST['invkp_paid_invoice'] );
            
            if (isset($_POST['invkp_custom_data_1']))
                update_post_meta( $post->ID, 'invkp_custom_data_1', $_POST['invkp_custom_data_1'] );
            if (isset($_POST['invkp_custom_data_2']))
                update_post_meta( $post->ID, 'invkp_custom_data_2', $_POST['invkp_custom_data_2'] );
            if (isset($_POST['invkp_custom_data_3']))
                update_post_meta( $post->ID, 'invkp_custom_data_3', $_POST['invkp_custom_data_3'] );
            if (isset($_POST['invkp_custom_data_4']))
                update_post_meta( $post->ID, 'invkp_custom_data_4', $_POST['invkp_custom_data_4'] );
            if (isset($_POST['invkp_custom_data_5']))
                update_post_meta( $post->ID, 'invkp_custom_data_5', $_POST['invkp_custom_data_5'] );
            if (isset($_POST['invkp_custom_data_6']))
                update_post_meta( $post->ID, 'invkp_custom_data_6', $_POST['invkp_custom_data_6'] );
            if (isset($_POST['invkp_custom_data_7']))
                update_post_meta( $post->ID, 'invkp_custom_data_7', $_POST['invkp_custom_data_7'] );
            if (isset($_POST['invkp_custom_data_8']))
                update_post_meta( $post->ID, 'invkp_custom_data_8', $_POST['invkp_custom_data_8'] );
            if (isset($_POST['invkp_custom_data_9']))
                update_post_meta( $post->ID, 'invkp_custom_data_9', $_POST['invkp_custom_data_9'] );
            if (isset($_POST['invkp_custom_data_10']))
                update_post_meta( $post->ID, 'invkp_custom_data_10', $_POST['invkp_custom_data_10'] );
	}
}

add_action( 'save_post', 'invkp_save_custom_fields' );

// Process the custom metabox fields
function invkp_return_fields( $id = NULL ) {
	global $post;
        if (is_null($id)) $id = $post->ID;
	$output = array();
        $output['invkp_company_name'] = get_post_meta( $id, 'invkp_company_name' );
        if (!isset($output['invkp_company_name'][0])) $output['invkp_company_name'][0] = get_option('invkp_company_name');
        
        $output['invkp_invoice_type'] = get_post_meta( $id, 'invkp_invoice_type' );
        if (!isset($output['invkp_invoice_type'][0])) $output['invkp_invoice_type'][0] = get_option('invkp_invoice_type');
        
        $output['invkp_address'] = get_post_meta( $id, 'invkp_address' );
        if (!isset($output['invkp_address'][0])) $output['invkp_address'][0] = get_option('invkp_address');
        $output['invkp_suburb'] = get_post_meta( $id, 'invkp_suburb' );
        if (!isset($output['invkp_suburb'][0])) $output['invkp_suburb'][0] = get_option('invkp_suburb');
        $output['invkp_state'] = get_post_meta( $id, 'invkp_state' );
        if (!isset($output['invkp_state'][0])) $output['invkp_state'][0] = get_option('invkp_state');
        $output['invkp_postcode'] = get_post_meta( $id, 'invkp_postcode' );
        if (!isset($output['invkp_postcode'][0])) $output['invkp_postcode'][0] = get_option('invkp_postcode');
        $output['invkp_date'] = (get_post_meta( $id, 'invkp_date' ) ? get_post_meta( $id, 'invkp_date' ) : array(''));
        $output['invkp_due_date'] = (get_post_meta( $id, 'invkp_due_date' ) ? get_post_meta( $id, 'invkp_due_date' ) : array(''));
        $output['invkp_invoice_no_label'] = get_post_meta( $id, 'invkp_invoice_no_label' );
        if (!isset($output['invkp_invoice_no_label'][0])) $output['invkp_invoice_no_label'][0] = get_option('invkp_invoice_no_label');
        $output['invkp_invoice_no'] = (get_post_meta( $id, 'invkp_invoice_no' ) ? get_post_meta( $id, 'invkp_invoice_no' ) : array(''));
        $output['invkp_po_label'] = get_post_meta( $id, 'invkp_po_label' );
        if (!isset($output['invkp_po_label'][0])) $output['invkp_po_label'][0] = get_option('invkp_po_label');
        $output['invkp_po'] = (get_post_meta( $id, 'invkp_po' ) ? get_post_meta( $id, 'invkp_po' ) : array(''));
        $output['invkp_tax_label'] = get_post_meta( $id, 'invkp_tax_label' );
        if (!isset($output['invkp_tax_label'][0])) $output['invkp_tax_label'][0] = get_option('invkp_tax_label');
        $output['invkp_payment_terms'] = (get_post_meta( $id, 'invkp_payment_terms' ) ? get_post_meta( $id, 'invkp_payment_terms' ) : array(''));
        
        $output['invkp_phone'] = get_post_meta( $id, 'invkp_phone' );
        if (!isset($output['invkp_phone'][0])) $output['invkp_phone'][0] = get_option('invkp_phone');
        $output['invkp_email'] = get_post_meta( $id, 'invkp_email' );
        if (!isset($output['invkp_email'][0])) $output['invkp_email'][0] = get_option('invkp_email');
        $output['invkp_add_detail'] = get_post_meta( $id, 'invkp_add_detail' );
        if (!isset($output['invkp_add_detail'][0])) $output['invkp_add_detail'][0] = get_option('invkp_add_detail');
        $output['invkp_attn_name_label'] = get_post_meta( $id, 'invkp_attn_name_label' );
        if (!isset($output['invkp_attn_name_label'][0])) $output['invkp_attn_name_label'][0] = get_option('invkp_attn_name_label');
        $output['invkp_attn_name'] = (get_post_meta( $id, 'invkp_attn_name' ) ? get_post_meta( $id, 'invkp_attn_name' ) : array(''));
        $output['invkp_client_company'] = (get_post_meta( $id, 'invkp_client_company' ) ? get_post_meta( $id, 'invkp_client_company' ) : array(''));
        $output['invkp_client_address'] = (get_post_meta( $id, 'invkp_client_address' ) ? get_post_meta( $id, 'invkp_client_address' ) : array(''));
        $output['invkp_client_suburb'] = (get_post_meta( $id, 'invkp_client_suburb' ) ? get_post_meta( $id, 'invkp_client_suburb' ) : array(''));
        $output['invkp_client_state'] = (get_post_meta( $id, 'invkp_client_state' ) ? get_post_meta( $id, 'invkp_client_state' ) : array(''));
        $output['invkp_client_postcode'] = (get_post_meta( $id, 'invkp_client_postcode' ) ? get_post_meta( $id, 'invkp_client_postcode' ) : array(''));
        $output['invkp_client_email'] = (get_post_meta( $id, 'invkp_client_email' ) ? get_post_meta( $id, 'invkp_client_email' ) : array(''));
        $output['invkp_client_phone'] = (get_post_meta( $id, 'invkp_client_phone' ) ? get_post_meta( $id, 'invkp_client_phone' ) : array(''));
        
        $output['invkp_selected_client_company'] = (get_post_meta( $id, 'invkp_selected_client_company' ) ? get_post_meta( $id, 'invkp_selected_client_company' ) : array(''));
        $output['invkp_selected_client_attn'] = (get_post_meta( $id, 'invkp_selected_client_attn' ) ? get_post_meta( $id, 'invkp_selected_client_attn' ) : array(''));
        $output['invkp_selected_client_address'] = (get_post_meta( $id, 'invkp_selected_client_address' ) ? get_post_meta( $id, 'invkp_selected_client_address' ) : array(''));
        $output['invkp_selected_client_suburb'] = (get_post_meta( $id, 'invkp_selected_client_suburb' ) ? get_post_meta( $id, 'invkp_selected_client_suburb' ) : array(''));
        $output['invkp_selected_client_state'] = (get_post_meta( $id, 'invkp_selected_client_state' ) ? get_post_meta( $id, 'invkp_selected_client_state' ) : array(''));
        $output['invkp_selected_client_postcode'] = (get_post_meta( $id, 'invkp_selected_client_postcode' ) ? get_post_meta( $id, 'invkp_selected_client_postcode' ) : array(''));
        $output['invkp_selected_client_email'] = (get_post_meta( $id, 'invkp_selected_client_email' ) ? get_post_meta( $id, 'invkp_selected_client_email' ) : array(''));
        $output['invkp_selected_client_phone'] = (get_post_meta( $id, 'invkp_selected_client_phone' ) ? get_post_meta( $id, 'invkp_selected_client_phone' ) : array(''));
        
        $output['invkp_column'] = (get_post_meta( $id, 'invkp_column' ) ? get_post_meta( $id, 'invkp_column' ) : array(''));
        $output['invkp_subtotal'] = (get_post_meta( $id, 'invkp_subtotal' ) ? get_post_meta( $id, 'invkp_subtotal' ) : array(''));
        $output['invkp_discount'] = (get_post_meta( $id, 'invkp_discount' ) ? get_post_meta( $id, 'invkp_discount' ) : array(''));
        $output['invkp_gst'] = (get_post_meta( $id, 'invkp_gst' ) ? get_post_meta( $id, 'invkp_gst' ) : array(''));
        $output['invkp_total'] = (get_post_meta( $id, 'invkp_total' ) ? get_post_meta( $id, 'invkp_total' ) : array(''));
        $output['invkp_open_content_1'] = get_post_meta( $id, 'invkp_open_content_1' );
        if (!isset($output['invkp_open_content_1'][0])) $output['invkp_open_content_1'][0] = get_option('invkp_open_content_1');
        $output['invkp_open_content_2'] = get_post_meta( $id, 'invkp_open_content_2' );
        if (!isset($output['invkp_open_content_2'][0])) $output['invkp_open_content_2'][0] = get_option('invkp_open_content_2');
        
        $output['invkp_columns'] = get_post_meta( $id, 'invkp_columns' );
        if (!isset($output['invkp_columns'][0])) $output['invkp_columns'][0] = serialize(get_option('invkp_columns'));
        $output['invkp_calculate_rows'] = get_post_meta( $id, 'invkp_calculate_rows' );
        if (!isset($output['invkp_calculate_rows'][0])) $output['invkp_calculate_rows'][0] = serialize(get_option('invkp_calculate_rows'));
        $output['invkp_calculate_operators'] = get_post_meta( $id, 'invkp_calculate_operators' );
        if (!isset($output['invkp_calculate_operators'][0])) $output['invkp_calculate_operators'][0] = serialize(get_option('invkp_calculate_operators'));
        $output['invkp_calculate_subtotal'] = get_post_meta( $id, 'invkp_calculate_subtotal' );
        if (!isset($output['invkp_calculate_subtotal'][0])) $output['invkp_calculate_subtotal'][0] = get_option('invkp_calculate_subtotal');
        
        $output['invkp_custom_data_1'] = (get_post_meta( $id, 'invkp_custom_data_1' ) ? get_post_meta( $id, 'invkp_custom_data_1' ) : array(''));
        $output['invkp_custom_data_2'] = (get_post_meta( $id, 'invkp_custom_data_2' ) ? get_post_meta( $id, 'invkp_custom_data_2' ) : array(''));
        $output['invkp_custom_data_3'] = (get_post_meta( $id, 'invkp_custom_data_3' ) ? get_post_meta( $id, 'invkp_custom_data_3' ) : array(''));
        $output['invkp_custom_data_4'] = (get_post_meta( $id, 'invkp_custom_data_4' ) ? get_post_meta( $id, 'invkp_custom_data_4' ) : array(''));
        $output['invkp_custom_data_5'] = (get_post_meta( $id, 'invkp_custom_data_5' ) ? get_post_meta( $id, 'invkp_custom_data_5' ) : array(''));
        $output['invkp_custom_data_6'] = (get_post_meta( $id, 'invkp_custom_data_6' ) ? get_post_meta( $id, 'invkp_custom_data_6' ) : array(''));
        $output['invkp_custom_data_7'] = (get_post_meta( $id, 'invkp_custom_data_7' ) ? get_post_meta( $id, 'invkp_custom_data_7' ) : array(''));
        $output['invkp_custom_data_8'] = (get_post_meta( $id, 'invkp_custom_data_8' ) ? get_post_meta( $id, 'invkp_custom_data_8' ) : array(''));
        $output['invkp_custom_data_9'] = (get_post_meta( $id, 'invkp_custom_data_9' ) ? get_post_meta( $id, 'invkp_custom_data_9' ) : array(''));
        $output['invkp_custom_data_10'] = (get_post_meta( $id, 'invkp_custom_data_10' ) ? get_post_meta( $id, 'invkp_custom_data_10' ) : array(''));
        
        $output['invkp_paid_invoice'] = (get_post_meta( $id, 'invkp_paid_invoice' ) ? get_post_meta( $id, 'invkp_paid_invoice' ) : array('0'));
        
        return $output;
}

function invkp_save_client_custom_fields( ) {
	global $post;	
        
        // verify nonce
        if (!isset($_POST['invkp_client_meta_box_nonce']) || !wp_verify_nonce($_POST['invkp_client_meta_box_nonce'], basename(__FILE__))) {
            return;
        }
	
	if( $_POST ) {
            if (isset($_POST['invkp_client_company_name']))
                update_post_meta( $post->ID, 'invkp_client_company_name', $_POST['invkp_client_company_name'] );
            if (isset($_POST['invkp_client_attn_name']))
                update_post_meta( $post->ID, 'invkp_client_attn_name', $_POST['invkp_client_attn_name'] );
            if (isset($_POST['invkp_client_address']))
                update_post_meta( $post->ID, 'invkp_client_address', $_POST['invkp_client_address'] );
            if (isset($_POST['invkp_client_suburb']))
                update_post_meta( $post->ID, 'invkp_client_suburb', $_POST['invkp_client_suburb'] );
            if (isset($_POST['invkp_client_state']))
                update_post_meta( $post->ID, 'invkp_client_state', $_POST['invkp_client_state'] );
            if (isset($_POST['invkp_client_postcode']))
                update_post_meta( $post->ID, 'invkp_client_postcode', $_POST['invkp_client_postcode'] );
            if (isset($_POST['invkp_client_email']))
                update_post_meta( $post->ID, 'invkp_client_email', $_POST['invkp_client_email'] );
            if (isset($_POST['invkp_client_phone']))
                update_post_meta( $post->ID, 'invkp_client_phone', $_POST['invkp_client_phone'] );
            
	}
}

add_action( 'save_post', 'invkp_save_client_custom_fields' );

// Process the custom metabox fields
function invkp_return_client_fields( $id = NULL ) {
	global $post;
        if (is_null($id)) $id = $post->ID;
	$output = array();
        
        $output['invkp_client_company_name'] = (get_post_meta( $id, 'invkp_client_company_name' ) ? get_post_meta( $post->ID, 'invkp_client_company_name' ) : array(''));
        $output['invkp_client_attn_name'] = (get_post_meta( $id, 'invkp_client_attn_name' ) ? get_post_meta( $post->ID, 'invkp_client_attn_name' ) : array(''));
        $output['invkp_client_address'] = (get_post_meta( $id, 'invkp_client_address' ) ? get_post_meta( $post->ID, 'invkp_client_address' ) : array(''));
        $output['invkp_client_suburb'] = (get_post_meta( $id, 'invkp_client_suburb' ) ? get_post_meta( $post->ID, 'invkp_client_suburb' ) : array(''));
        $output['invkp_client_state'] = (get_post_meta( $id, 'invkp_client_state' ) ? get_post_meta( $post->ID, 'invkp_client_state' ) : array(''));
        $output['invkp_client_postcode'] = (get_post_meta( $id, 'invkp_client_postcode' ) ? get_post_meta( $post->ID, 'invkp_client_postcode' ) : array(''));
        $output['invkp_client_email'] = (get_post_meta( $id, 'invkp_client_email' ) ? get_post_meta( $post->ID, 'invkp_client_email' ) : array(''));
        $output['invkp_client_phone'] = (get_post_meta( $id, 'invkp_client_phone' ) ? get_post_meta( $post->ID, 'invkp_client_phone' ) : array(''));
        
        return $output;
}

// Remove the Permalinks
function invkp_perm($return, $id, $new_title, $new_slug){
    global $post;
    if(isset($post->post_type) && $post->post_type == 'invkp_invoices') return '';
    return $return;
}
add_filter('get_sample_permalink_html', 'invkp_perm', '', 4);

// Dashboard Widget

function invkp_enqueue($hook) {
    
    wp_register_style( 'invkp_css', plugins_url('css/invoicekingpro-styles.css', dirname(__FILE__)), false, '1.0.0' );
    $theme = get_option('invkp_theme');
    wp_register_style( 'invkp_'.$theme.'_css', plugins_url('themes/'.$theme.'/styles.css', dirname(__FILE__)), false, '1.0.0' );
    
    wp_enqueue_style( 'invkp_css' );
    wp_enqueue_style( 'invkp_'.$theme.'_css' );
    
    wp_register_script( 'invkp_elastic', plugins_url( '/js/jquery.elastic.source.js', dirname(__FILE__) ), array('jquery'), '1.6.11');
    wp_register_script( 'invkp_admin_js', plugins_url( '/js/invoicekingpro-admin-functions.js', dirname(__FILE__) ), array('jquery'), '1.0.0');
    
    wp_enqueue_script( 'invkp_elastic' );
    wp_enqueue_script( 'invkp_admin_js' );

    // in javascript, object properties are accessed as ajax_object.ajax_url, ajax_object.we_value
    wp_localize_script( 'invkp-admin', 'invkp_ajax_object',
        array( 'ajax_url' => admin_url( 'admin-ajax.php' ), 'invkp_ajaxnonce' => wp_create_nonce( 'invkpN0nc3' ) ) );
}
add_action( 'admin_enqueue_scripts', 'invkp_enqueue' );

// Add settings area 
function invoicekingpro_settings() {
	add_options_page('Invoice King Pro', 'Invoice King Pro', 'manage_options', 'invoicekingpro', 'invkp_settings_output');
}
add_action('admin_menu', 'invoicekingpro_settings');

function register_invkp_options() {
    
    register_setting( 'invkp-options', 'invkp_theme' );
    
    register_setting( 'invkp-options', 'invkp_revenue_currency' );
  
    register_setting( 'invkp-options', 'invkp_company_name' );
    register_setting( 'invkp-options', 'invkp_address' );
    register_setting( 'invkp-options', 'invkp_suburb' );
    register_setting( 'invkp-options', 'invkp_state' );
    register_setting( 'invkp-options', 'invkp_postcode' );
    register_setting( 'invkp-options', 'invkp_phone' );
    register_setting( 'invkp-options', 'invkp_email' );
    register_setting( 'invkp-options', 'invkp_add_detail' );

    register_setting( 'invkp-options', 'invkp_invoice_type' );
    register_setting( 'invkp-options', 'invkp_paid_invoice_type' );
    register_setting( 'invkp-options', 'invkp_paid_watermark' );
    register_setting( 'invkp-options', 'invkp_invoice_no_label' );
    register_setting( 'invkp-options', 'invkp_po_label' );
    register_setting( 'invkp-options', 'invkp_attn_name_label' );
    register_setting( 'invkp-options', 'invkp_tax_label' );
    
    register_setting( 'invkp-options', 'invkp_open_content_1' );
    register_setting( 'invkp-options', 'invkp_open_content_2' );
    
    register_setting( 'invkp-options', 'invkp_columns' );
    
    register_setting( 'invkp-options', 'invkp_calculate_rows' );
    register_setting( 'invkp-options', 'invkp_calculate_operators' );

    register_setting( 'invkp-options', 'invkp_calculate_subtotal' );
    
    register_setting( 'invkp-options', 'invkp_from');
    register_setting( 'invkp-options', 'invkp_from_email');
    register_setting( 'invkp-options', 'invkp_email_subject');
    register_setting( 'invkp-options', 'invkp_email_message');
    register_setting( 'invkp-options', 'invkp_paid_email_subject');
    register_setting( 'invkp-options', 'invkp_paid_email_message');
}
add_action( 'admin_init', 'register_invkp_options' );

function invkp_settings_output() {
	?>
<div class="wrap">
<?php screen_icon(); ?>
<h2>Invoice King Pro</h2>
<div class="invkp_settings">
<form method="post" action="options.php">
<?php settings_fields('invkp-options'); ?>
<?php do_settings_sections('invkp-options'); ?>
    <table class="form-table">
        <tr valign="top">
        <th scope="row">Invoice Theme</th>
        <td>
            <?php $val = get_option('invkp_theme'); ?>
            <select name="invkp_theme">
                <?php
                    $folder = scandir(str_replace("includes/","",plugin_dir_path(__FILE__)).'themes/');
                    $exclude = array('.', '..');
                    foreach ($folder as $f) {
                        if (!in_array($f, $exclude)) {
                            $selected = '';
                            if ($val == $f) $selected = ' selected';
                            echo '<option value="'.$f.'"'.$selected.'>'.ucwords(str_replace(array('-', '_'), ' ', $f)).'</option>';
                        }
                    }
                ?>
            </select>
        </td>
        <td>* More themes can be downloaded from <a href="http://durham.net.au/wordpress/plugins/invoice-king-pro/" target="_blank">my website</a></td>
        </tr>
        
        <?php if ( function_exists( 'invkp_theme_options' ) ) :
            invkp_theme_options();
         endif; ?>
        
        <tr valign="top"><td colspan="3" style="border-bottom: 1px solid #ccc;"></td></tr>
        <tr valign="top">
        <th scope="row">Currency Symbol</th>
        <td>
            <?php $val = get_option('invkp_revenue_currency'); ?>
            <input type="text" name="invkp_revenue_currency" value="<?= $val ?>" />
        </td>
        <td></td>
        </tr>
        
        <tr valign="top"><td colspan="3" style="border-bottom: 1px solid #ccc;"></td></tr>
        <tr valign="top">
        <th scope="row">Your Company Name</th>
        <td>
            <?php $val = get_option('invkp_company_name'); ?>
            <input type="text" name="invkp_company_name" value="<?= $val ?>" />
        </td>
        <td></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Your Address</th>
        <td>
            <?php $val = get_option('invkp_address'); ?>
            <input type="text" name="invkp_address" value="<?= $val ?>" />
        </td>
        <td></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Your Suburb/Town</th>
        <td>
            <?php $val = get_option('invkp_suburb'); ?>
            <input type="text" name="invkp_suburb" value="<?= $val ?>" />
        </td>
        <td></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Your State</th>
        <td>
            <?php $val = get_option('invkp_state'); ?>
            <input type="text" name="invkp_state" value="<?= $val ?>" />
        </td>
        <td></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Your Postcode/Zip</th>
        <td>
            <?php $val = get_option('invkp_postcode'); ?>
            <input type="text" name="invkp_postcode" value="<?= $val ?>" />
        </td>
        <td></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Your Phone</th>
        <td>
            <?php $val = get_option('invkp_phone'); ?>
            <input type="text" name="invkp_phone" value="<?= $val ?>" />
        </td>
        <td></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Your Email</th>
        <td>
            <?php $val = get_option('invkp_email'); ?>
            <input type="text" name="invkp_email" value="<?= $val ?>" />
        </td>
        <td></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Additional Detail</th>
        <td>
            <?php $val = get_option('invkp_add_detail'); ?>
            <input type="text" name="invkp_add_detail" value="<?= $val ?>" />
        </td>
        <td>eg Business Details (ie ABN)</td>
        </tr>
        
        <tr valign="top"><td colspan="3" style="border-bottom: 1px solid #ccc;"></td></tr>
        
        <tr valign="top">
        <th scope="row">Invoice Type Label</th>
        <td>
            <?php $val = get_option('invkp_invoice_type'); ?>
            <input type="text" name="invkp_invoice_type" value="<?= $val ?>" />
        </td>
        <td></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Paid Invoice Type Label</th>
        <td>
            <?php $val = get_option('invkp_paid_invoice_type'); ?>
            <input type="text" name="invkp_paid_invoice_type" value="<?= $val ?>" />
        </td>
        <td></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Paid Invoice Watermark</th>
        <td>
            <?php $val = get_option('invkp_paid_watermark'); ?>
            <input type="text" name="invkp_paid_watermark" value="<?= $val ?>" />
        </td>
        <td></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Invoice Number Label</th>
        <td>
            <?php $val = get_option('invkp_invoice_no_label'); ?>
            <input type="text" name="invkp_invoice_no_label" value="<?= $val ?>" />
        </td>
        <td></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Purchase Order Label</th>
        <td>
            <?php $val = get_option('invkp_po_label'); ?>
            <input type="text" name="invkp_po_label" value="<?= $val ?>" />
        </td>
        <td></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Attention to Label</th>
        <td>
            <?php $val = get_option('invkp_attn_name_label'); ?>
            <input type="text" name="invkp_attn_name_label" value="<?= $val ?>" />
        </td>
        <td></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">GST/Tax Label</th>
        <td>
            <?php $val = get_option('invkp_tax_label'); ?>
            <input type="text" name="invkp_tax_label" value="<?= $val ?>" />
        </td>
        <td></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Open Content Block 1</th>
        <td>
            <?php $val = get_option('invkp_open_content_1'); ?>
            <textarea name="invkp_open_content_1"><?= $val ?></textarea>
        </td>
        <td></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Open Content Block 2</th>
        <td>
            <?php $val = get_option('invkp_open_content_2'); ?>
            <textarea name="invkp_open_content_2"><?= $val ?></textarea>
        </td>
        <td></td>
        </tr>
        
        <tr valign="top"><td colspan="3" style="border-bottom: 1px solid #ccc;"></td></tr>
        
        <tr valign="top">
        <th scope="row">Define Columns</th>
        <td>
            <div class="invkp_columns">
            <?php $val = get_option('invkp_columns'); ?>
            <?php if (is_array($val)) : ?>
            <?php $count = 1; foreach ($val as $col) : ?>
            <input type="text" name="invkp_columns[]" value="<?= $col ?>" />
            <?php if ($count > 1) : ?><a class="remove_invkp_column">Remove</a><?php endif; ?>
            <br />
            <?php $count++; endforeach; ?>
            <?php else : ?>
            <input type="text" name="invkp_columns[]" value="" /><br />
            <?php endif; ?>
            </div>
            <br />
            <a class="add_invkp_column">Add Column</a>
        </td>
        <td></td>
        </tr>
        
        <tr valign="top"><td colspan="3" style="border-bottom: 1px solid #ccc;"></td></tr>
        
        <tr valign="top">
        <th scope="row">Row Calculation</th>
        <td>
            <div class="invkp_row_calculation">
                <?php 
                $val = get_option('invkp_columns');
                $cols = array();
                if (is_array($val)) :
                    foreach ($val as $col)
                        $cols[] = $col;
                endif; 
                $calc_cols = get_option('invkp_calculate_rows');
                $calc_ops = get_option('invkp_calculate_operators');
                
                if (!empty($calc_cols) && isset($calc_ops[0]) && $calc_ops[0] <> '') :
                    for ($c=0;$c<count($calc_cols); $c++) :
                        if ($calc_cols[$c] <> '') :
                ?>
                <select name="invkp_calculate_rows[]" class="row">
                    <option value="">-- SELECT --</option>
                    <?php foreach ($cols as $col) : ?>
                    <option value="<?= $col ?>"<?php if ($calc_cols[$c] == $col) echo ' selected'; ?>><?= $col ?></option>
                    <?php endforeach ?>
                </select>
                <br />
                <?php if (isset($calc_ops[$c]) && $calc_ops[$c] <> '') : ?>
                <select name='invkp_calculate_operators[]'>
                    <option value=''>-- SELECT--</option>
                    <option value='*'<?php if ($calc_ops[$c] == '*') echo ' selected'; ?>>*</option>
                    <option value='+'<?php if ($calc_ops[$c] == '+') echo ' selected'; ?>>+</option>
                    <option value='/'<?php if ($calc_ops[$c] == '/') echo ' selected'; ?>>/</option>
                    <option value='-'<?php if ($calc_ops[$c] == '-') echo ' selected'; ?>>-</option>
                    <option value='='<?php if ($calc_ops[$c] == '=') echo ' selected'; ?>>=</option>
                </select>
                <br />
                <?php endif; endif; endfor; ?>
                <?php endif; ?>
                <select name="invkp_calculate_rows[]" class="row">
                    <option value="">-- SELECT --</option>
                    <?php foreach ($cols as $col) : ?>
                    <option value="<?= $col ?>"><?= $col ?></option>
                    <?php endforeach ?>
                </select>
                <br />
            </div>
        </td>
        <td>Options available after "Define Columns" saved.</td>
        </tr>
        
        <tr valign="top"><td colspan="3" style="border-bottom: 1px solid #ccc;"></td></tr>
        
        <tr valign="top">
        <th scope="row">Subtotals Calculation Column</th>
        <td>
            <?php 
            $subtotal_col = get_option('invkp_calculate_subtotal');
            $val = get_option('invkp_columns');
            $cols = array();
            if (is_array($val)) :
                foreach ($val as $col)
                    $cols[] = $col;
            endif; 
            ?>
            <select name="invkp_calculate_subtotal">
                <option value="">-- SELECT --</option>
                <?php foreach ($cols as $col) : ?>
                <option value="<?= $col ?>"<?php if ($subtotal_col == $col) echo ' selected'; ?>><?= $col ?></option>
                <?php endforeach ?>
            </select>
        </td>
        <td>Options available after "Define Columns" saved.</td>
        </tr>
        
        <tr valign="top"><td colspan="3" style="border-bottom: 1px solid #ccc;"></td></tr>
        
        <tr valign="top">
        <th scope="row">From Name</th>
        <td>
            <?php $val = get_option('invkp_from'); ?>
            <input type="text" name="invkp_from" value="<?= $val ?>" />
        </td>
        <td></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">From Email</th>
        <td>
            <?php $val = get_option('invkp_from_email'); ?>
            <input type="text" name="invkp_from_email" value="<?= $val ?>" />
        </td>
        <td></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Subject</th>
        <td>
            <?php $val = get_option('invkp_email_subject'); ?>
            <input type="text" name="invkp_email_subject" value="<?= $val ?>" />
        </td>
        <td></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Message</th>
        <td>
            <?php $val = get_option('invkp_email_message'); ?>
            <textarea name="invkp_email_message" style="height: 280px; width: 275px;"><?= $val ?></textarea>
        </td>
        <td></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Paid Subject</th>
        <td>
            <?php $val = get_option('invkp_paid_email_subject'); ?>
            <input type="text" name="invkp_paid_email_subject" value="<?= $val ?>" />
        </td>
        <td></td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Paid Message</th>
        <td>
            <?php $val = get_option('invkp_paid_email_message'); ?>
            <textarea name="invkp_paid_email_message" style="height: 280px; width: 275px;"><?= $val ?></textarea>
        </td>
        <td></td>
        </tr>
        
    </table>
<?php submit_button(); ?>
</form>
</div>
<div class="akp_faq_help">
    <div class="akp_faq">
        <h2>How To Use</h2>
        <h3>1) Set your defaults</h3>
        <p>Default fields have been provided to the left to auto-populate common data on each invoice you create. You are able to modify all default data on each invoice to suit if needed.</p>
        <h3>2) Define your columns</h3>
        <p>Invoice King Pro is customisable right down to the columns you have in your invoice. Have as many or as little as you need. Keep in mind that the more columns you have the thinner the column width will be.</p>
        <h3>3) Define your row calculation</h3>
        <p>As your columns are completely customised by you, the system has no way to know what columns are part of your calculations unless you tell it. As you select a column from the dropdown provided (the dropdowns are populated after you save the settings with your columns defined), you will be given an operator to append to the calculation.</p>
        <p>Selecting the operator will give you another dropdown of columns. Continue this for all columns you need to include. Once you have chosen the columns and the operators that you need to give you a total for the row, select the equals operator followed by the row totals column.</p>
        <p>An example would be "Hours" "*" "Hourly Rate" "=" "Total". This will times the hours by your hourly rate and put the total in the total column.</p>
        <h3>4) Select the column to calculate the subtotal</h3>
        <p>Following the process that the system doesn't know what columns you may have, it needs to know what your row total column is to be able to calculate the subtotal and complete the calculation of the invoice. This dropdown will be populated once you have save the settings with the columns defined.</p>
        
        <h3>Setup Email Message</h3>
        <p>You have the option to modify the default email subject and message the sends with your invoice. There are dynamic variables in place that you can call into your subject line and message. They are:</p>
        <ul>
            <li><strong>{{invoice_type}}</strong> - The status of the invoice being sent. By default this is either Invoice or Receipt</li>
            <li><strong>{{invoice_number_label}}</strong> - The invoice number label you set to the left</li>
            <li><strong>{{invoice_number}}</strong> - The invoice number you set to the invoice being sent</li>
            <li><strong>{{invoice_date}}</strong> - The date you enter on the invoice being sent</li>
            <li><strong>{{invoice_due_date}}</strong> - The due date you enter on the invoice being sent</li>
            <li><strong>{{client_company_name}}</strong> - The client company name of the selected client (not the company name on the invoice) attached to the invoice being sent</li>
            <li><strong>{{client_name}}</strong> - The Attn name of your selected client (not the Attn name on the invoice) attached to the invoice being sent</li>
            <li><strong>{{invoice_total}}</strong> - The total of the invoice that is being sent</li>
        </ul>
        
        <h3>Install PDF Themes</h3>
        <p>Download themes from <a href="http://durham.net.au/wordpress/plugins/invoice-king-pro/" target="_blank">my plugin page</a>. Locate the themes folder in the invoicekingpro plugin folder, generally located:</p>
        <pre>/wp-content/plugins/invoicekingpro/themes/</pre>
        <p>Unzip the downloaded zip file and upload the entire folder into the themes folder mentioned above.</p>
        <p>Once uploaded, return to this page and your theme will be present in the PDF Theme dropdown to the left. Choose the theme and save the options. Next time you generate a report, the theme you have chosen will be used.</p>
        <p>The ability to upload the zip file straight from here will be added soon</p>
    </div>
    
    <div class="akp_help">
        <h2>FAQ</h2>
        <h4>Q. I change my columns in the settings yet my existing invoices don't show the change. Why?</h4>
        <p>This is done to protect your existing invoices from future updates. You may run your invoices with a specific set of information
        for a year then update the set which wouldn't match your old invoices. If this wasn't in place your old invoice data would be lost.</p>
        <h4>Q. Some fields I see used around the plugin don't exist on my invoice. How do I set them?</h4>
        <p>Not all themes will use every field available in the system. For example, the default theme that comes with the plugin does not use the clients
        contact details (address, phone, email) on the invoice, nor does the due date field get used. Some of the other themes available may use these.</p>
        <h4>Q. I made a change to my invoice and viewed the PDF to see the update, but it hasn't changed. Why?</h4>
        <p>If your viewing this in the browser then its highly possible that your viewing a cached version. You should get your new version simply by
        refreshing the page. Depending on what browser you use will determine how it displays the PDF to you. You shouldn't have this problem if you download it.</p>
        <h4>I get an error saying the PDF can't be saved due to write permissions on the server. What do I do?</h4>
        <p>The plugin needs your permission to save the PDFs you generate to the output folder in the plugins folder. To do this, you are required to
        update the outputs permissions to be writable. Please see <a href="http://codex.wordpress.org/Changing_File_Permissions" target="_blank">the wordpress help page</a> to carry this out.</p>
        
        <h4>Found an issue? Please email your concern to <a href="mailto:contact@durham.net.au">contact@durham.net.au</a></h4>
    </div>
</div>
</div>
<?php } ?>
