<?php
    $pdf = new FPDF('P','mm','A4');
    $pdf->AliasNbPages();
    $pdf->AddPage();
    
    if ($invoice[0]->custom['invkp_paid_invoice'][0] == 1)
        $pdf->watermark(iconv('UTF-8', 'windows-1252', $paid_watermark));

    $pdf->SetX(15); $pdf->SetY($pdf->GetY() + 5);
    $pdf->SetFont('Arial','B',20);
    $pdf->Cell(95,8,iconv('UTF-8', 'windows-1252', $invoice[0]->custom['invkp_company_name'][0]),0,0,'L');
    $pdf->SetFont('Arial','B',24);
    if ($invoice[0]->custom['invkp_paid_invoice'][0] == 1)
        $pdf->Cell(95,8,iconv('UTF-8', 'windows-1252', $paid_label),0,0,'R');
    else
        $pdf->Cell(95,8,iconv('UTF-8', 'windows-1252', $invoice[0]->custom['invkp_invoice_type'][0]),0,0,'R');
    $pdf->Ln(15);
    
    $pdf->SetX(10);
    $cur_y = $pdf->GetY();
    $pdf->SetFont('Arial', '', 9);
    $pdf->MultiCell(95, 4, iconv('UTF-8', 'windows-1252', $invoice[0]->custom['invkp_address'][0])."\r\n".iconv('UTF-8', 'windows-1252', $invoice[0]->custom['invkp_suburb'][0])."\r\n".iconv('UTF-8', 'windows-1252', $invoice[0]->custom['invkp_state'][0])." ".iconv('UTF-8', 'windows-1252', $invoice[0]->custom['invkp_postcode'][0])."\r\n\r\n".iconv('UTF-8', 'windows-1252', $invoice[0]->custom['invkp_phone'][0])."\r\n".iconv('UTF-8', 'windows-1252', $invoice[0]->custom['invkp_email'][0])."\r\n".iconv('UTF-8', 'windows-1252', $invoice[0]->custom['invkp_add_detail'][0]));
    
    $pdf->SetY($cur_y);
    $pdf->SetX(105);
    $pdf->MultiCell(95, 4, iconv('UTF-8', 'windows-1252', $invoice[0]->custom['invkp_date'][0])."\r\n".iconv('UTF-8', 'windows-1252', $invoice[0]->custom['invkp_invoice_no_label'][0])." ".iconv('UTF-8', 'windows-1252', $invoice[0]->custom['invkp_invoice_no'][0])."\r\n".iconv('UTF-8', 'windows-1252', $invoice[0]->custom['invkp_po_label'][0])." ".iconv('UTF-8', 'windows-1252', $invoice[0]->custom['invkp_po'][0]), 0, 'R');
    $pdf->Ln(4);
    $pdf->SetX(105);
    $pdf->SetFont('Arial','B',16);
    $pdf->MultiCell(95, 7, iconv('UTF-8', 'windows-1252', $invoice[0]->custom['invkp_attn_name_label'][0])." ".iconv('UTF-8', 'windows-1252', $invoice[0]->custom['invkp_attn_name'][0])."\r\n".iconv('UTF-8', 'windows-1252', $invoice[0]->custom['invkp_client_company'][0]), 0, 'R');
    $pdf->Ln(6);
    
    $cur_y = $pdf->GetY();
    $pdf->SetDrawColor(204, 204, 204);
    $pdf->Rect(10, $cur_y, 190, 0);
    
    $pdf->SetX(10);
    $pdf->SetY($cur_y+7);
    $pdf->SetFont('Arial', '', 9);
    $pdf->MultiCell(190, 4, iconv('UTF-8', 'windows-1252', $invoice[0]->custom['invkp_open_content_1'][0]));
    
    $cur_y = $pdf->GetY();
    $pdf->SetFillColor(255,255,255);
    $pdf->SetTextColor(0,0,0);
    $pdf->SetX(10);
    $pdf->SetY($cur_y+10);
    $pdf->SetFont('Arial','B',9);
    $pdf->SetFillColor(227,227,227);
    $col_width = 190 / count($columns);
    foreach ($columns as $column)
        $pdf->Cell($col_width,5,iconv('UTF-8', 'windows-1252', $column),1,0,'C',1);
    $pdf->Ln(5);
    $pdf->SetFillColor(255,255,255);
    $pdf->SetX(10);
    $pdf->SetFont('Arial','',9);
    
    $r = 0;
    foreach ($rows as $row) :
        if ($r % 2) {
            $pdf->SetFillColor(238,238,238);
            $fill = 1;
        } else {
            $pdf->SetFillColor(255,255,255);
            $fill = 0;
        }
        foreach ($columns as $column) :
            $align = 'L';
            if (is_numeric($row[$column])) $align = 'C';
            if (preg_match('/^\d+\.\d+$/',$row[$column])) {
                $align = 'R';
                $row[$column] = iconv('UTF-8', 'windows-1252', $currency_symbol).iconv('UTF-8', 'windows-1252', $row[$column]);
            }
            $pdf->Cell($col_width,5,$row[$column],1,0,$align,$fill);
        endforeach;
        $pdf->Ln(5); 
        $r++;
    endforeach;
    
    $pdf->SetY($pdf->GetY()+7);
    
    $pdf->SetFillColor(255,255,255);
    
    for ($c=0;$c<count($columns);$c++) :
        if ($c == count($columns)-2) :
            $pdf->SetFont('Arial','B',9);
            $pdf->Cell($col_width,5,'Subtotal',0,0,'R',0);
        elseif ($c == count($columns)-1) :
            $pdf->SetFont('Arial','',9);
            $pdf->Cell($col_width,5,iconv('UTF-8', 'windows-1252', $currency_symbol).$invoice[0]->custom['invkp_subtotal'][0],0,0,'R',0);
        else :
            $pdf->Cell($col_width,5,'',0,0,'C',0);
        endif;
    endfor;
    $pdf->Ln(5);
    
    for ($c=0;$c<count($columns);$c++) :
        if ($c == count($columns)-2) :
            $pdf->SetFont('Arial','B',9);
            $pdf->Cell($col_width,5,'Discount',0,0,'R',0);
        elseif ($c == count($columns)-1) :
            $pdf->SetFont('Arial','',9);
            $pdf->Cell($col_width,5,iconv('UTF-8', 'windows-1252', $currency_symbol).$invoice[0]->custom['invkp_discount'][0],0,0,'R',0);
        else :
            $pdf->Cell($col_width,5,'',0,0,'C',0);
        endif;
    endfor;
    $pdf->Ln(5);
    
    for ($c=0;$c<count($columns);$c++) :
        if ($c == count($columns)-2) :
            $pdf->SetFont('Arial','B',9);
            $pdf->Cell($col_width,5,$tax_label,0,0,'R',0);
        elseif ($c == count($columns)-1) :
            $pdf->SetFont('Arial','',9);
            $pdf->Cell($col_width,5,iconv('UTF-8', 'windows-1252', $currency_symbol).$invoice[0]->custom['invkp_gst'][0],0,0,'R',0);
        else :
            $pdf->Cell($col_width,5,'',0,0,'C',0);
        endif;
    endfor;
    $pdf->Ln(5);
    
    for ($c=0;$c<count($columns);$c++) :
        if ($c == count($columns)-2) :
            $pdf->SetFont('Arial','B',9);
            $pdf->Cell($col_width,5,"Total",0,0,'R',0);
        elseif ($c == count($columns)-1) :
            $pdf->SetFont('Arial','',9);
            $pdf->Cell($col_width,5,iconv('UTF-8', 'windows-1252', $currency_symbol).$invoice[0]->custom['invkp_total'][0],0,0,'R',0);
        else :
            $pdf->Cell($col_width,5,'',0,0,'C',0);
        endif;
    endfor;
    $pdf->Ln(5);
    $pdf->SetX(10);
    $pdf->SetY($pdf->GetY()+10);
    $pdf->SetFont('Arial', '', 9);
    $pdf->MultiCell(190, 4, iconv('UTF-8', 'windows-1252', $invoice[0]->custom['invkp_open_content_2'][0]));
    
    

    $pdf_path = plugin_dir_path(__FILE__)."../../outputs/".$invoice[0]->ID.".pdf";
    $pdf->Output($pdf_path, "F");
?>